# Drupal NFT

## Introduction

This module aims to provide several tools to use NFTs in your Drupal site.

Currently, only `nft_media` is available.

## Requirements

This module has the following requirements:

- OEmbed Providers 2.0.0+

Consequently, it relies on:

- Drupal Drupal 9.0.0+
- Media (included in core)

## Installation

Install as you would normally install a contributed Drupal module.

```
composer require drupal/nft
drush en nft
```

Note: The `nft` module does nothing on its own. You certainly want to activate
the "NFT - Media" to use non-fungible tokens in your site. Read _Usage_ sections
below for further information about submodules.

## Usage

### Use NFT as media

Install the `nft_media` submodule:

```
drush en nft_media
```

This module creates a new media type during installation, namely `nft`. If your
site already has a media bundle `nft`, you would have to create a new media type
yourself as follow:

- Go to Admin > Structure > Media type
- Create a new media type
- Select **NFT** as the source plugin

The _NFT_ source is a custom media source which is automatically created during
installation thanks to a custom _Provider Bucket_ configuration. Visit the
[OEmbed Provider module page](https://www.drupal.org/project/oembed_providers)
for further information about Provider Buckets.

### Future developments

The following ideas are being discussed to extend NFT-related functionalities:

- Retrieve NFT from a given wallet
- Login with an NFT (because, why not?)
- Mint NFT from Drupal entities (e.g. NFT node owner)
- Mint NFT as a Commerce payment gateway

## Maintainers

Current maintainers:

- [Matthieu Scarset](https://www.drupal.org/u/matthieuscarset)

This project has been initiated during NFT Hack 2022 by

- [ETHGlobal](https://showcase.ethglobal.com/)
